#! /usr/bin/env python

"""New better revision.  Also works with a little bit older python versions."""

import sys
import getopt
import os

def usage(utyp, *msg):
    sys.stderr.write('Usage: %s unpatched-bash new-patched-bash\n' % os.path.split(sys.argv[0])[1])
    if msg:
        sys.stderr.write('Error: %s\n' % `msg`)
    sys.exit(1)

def all_magics(d,ms='() {\x00'):
    p = 0
    while 1:
        p = d.find(ms,p)
        if p < 0:
            break
        yield p
        p = p+1

class Global:
    def __init__(self):
        self.multiple = False
        return
    def doit(self,args):
        if len(args) != 2:
            usage(0)
        unpatched = args.pop(0)
        patched = args.pop(0)
        d = file(unpatched,'rb').read()
        nfound = 0
        for p in all_magics(d):
            sys.stderr.write('@ %d\n' % (p,))
            if self.multiple or nfound == 0:
                d = ''.join((d[:p],'\x00',d[p+1:]))
            nfound = nfound+1
        if nfound:
            file(patched,'wb').write(d)
            sys.stderr.write('Patched %s to %s\n' % (unpatched,patched))
            if nfound > 1 and not self.multiple:
                sys.stderr.write('Found %d but patched only first one.\n' % (nfound,))
                sys.stderr.write('To patch all, rerun with -m flag\n')
        else:
            sys.stderr.write('Cannot find "() {"\n')
        return

def main(argv):
    gp = Global()
    try:
        opts, args = getopt.getopt(argv[1:],
                                   'hm',
                                   ['help',
                                    'multiple',
                                    ])
    except getopt.error, msg:
        usage(1, msg)

    for opt, arg in opts:
        if opt in ('-h', '--help'):
            usage(0)
        elif opt in ('-m', '--multiple'):
            gp.multiple = True
        else:
            usage(0)

    gp.doit(args)
        
if __name__ == '__main__':
    main(sys.argv)
